(*
**
** Strong normalization for System F
**
*)

(*
** Interpretation of types 
*)

(* Int : {m|Nat}(Ty m)->(VEC (Tm->Set) m)->(Tm->Set)

rec Int m (t_var i) = [v:VEC (Tm->Set) m]V_nth i v
  | Int m (arr s t) = [v:VEC (Tm->Set) m]ARR (Int s v) (Int t v)
  | Int m (pi t)    = [v:VEC (Tm->Set) m]PI [P:Tm->Set]Int t (V_cons P v)
*)

[Int = RecTyN ([m:Nat](VEC (Tm->Set) m)->(Tm->Set))
	([m|Nat][i:Fin m]
	 [v:VEC (Tm->Set) m]V_nth i v)
	([m|Nat][s:Ty m][Int_s:(VEC (Tm->Set) m)->(Tm->Set)]
		[t:Ty m][Int_t:(VEC (Tm->Set) m)->(Tm->Set)]
	 [v:VEC (Tm->Set) m]ARR (Int_s v) (Int_t v))
	([m|Nat][t:Ty (succ m)][Int_t:(VEC (Tm->Set) (succ m))->(Tm->Set)]
	 [v:VEC (Tm->Set) m]PI [P:Tm->Set]Int_t (V_cons P v))];

Goal {m|Nat}{t:Ty m}{v:VEC (Tm->Set) m}
	({i:Fin m}CR (V_nth i v))
	-> (CR (Int t v));
Refine RecTy ([m|Nat][t:Ty m]{v:VEC (Tm->Set) m}
	({i:Fin m}CR (V_nth i v))
	-> (CR (Int t v)));
(* t_var *) intros;Refine H;
(* arr s t *) intros;Refine CR_ARR;Refine H;Refine H2;
Refine H1;Refine H2;
(* t_pi t *) intros;Refine CR_PI;intros;Refine H;
Refine RecFin1 [i:Fin (succ n)]CR (V_nth i (V_cons P v));
Refine H2;Refine H1;
Save CR_Int;

(*
** Correctness of weakening and substitution
*)

Goal {m,l:Nat}{t:Ty (add l m)}{v1:VEC (Tm->Set) l}{v2:VEC (Tm->Set) m}
	{M:Tm}{P:Tm->Set}
	iff (Int t (V_append v1 v2) M)
	    (Int (t_weak t) (V_insert v1 P v2) M);
intros m;
Refine RecTy1 m [l:Nat][t:Ty (add l m)]
	{v1:VEC (Tm->Set) l}{v2:VEC (Tm->Set) m}{M:Tm}{P:Tm->Set}
	iff (Int t (V_append v1 v2) M)
	    (Int (t_weak t) (V_insert v1 P v2) M);
(*** t_var ***)
intros;
Refine RecVEC [l|Nat][v1:VEC (Tm->Set) l]
	{p:Fin (add l m)}
	   iff (Int (t_var p) (V_append v1 v2) M) (Int (t_weak (t_var p)) 
	       (V_insert v1 P v2) M);
(** v1 = V_nil **)
intros;Refine iff_refl;
(** V_cons R v1 **)
intros R l v IH;
Refine RecFin1 [p:Fin (add (succ l1) m)]
	iff (Int (t_var p) (V_append (V_cons R v) v2) M) 
	    (Int (t_weak (t_var p)) (V_insert (V_cons R v) P v2) M);
(* p=f_zero *) Refine iff_refl;
(* f_succ p1 *) intros p1;Refine IH;
(*** arr ***)
intros l s IH_s t IH_t v1 v2 M1 P;andI;
(** fst **) 
Intros;Refine fst (IH_t ? ? ? ?);Refine H;Refine snd (IH_s ? ? ? ?);Next +1;
Refine H1;
(** snd **)
Intros;Refine snd (IH_t ? ? ? ?);Next +1;Refine H;Refine fst (IH_s ? ? ? ?);
Refine H1;
(*** pi ***)
intros l s IH_s ____;andI;
(** fst **) 
intros;Equiv Int (pi (t_weak|m|(succ l) s)) (V_insert v1 P v2) M;
Intros;Equiv Int (t_weak|m|(succ l) s) (V_insert (V_cons P1 v1) P v2) M;
Refine fst (IH_s ? ? ? ?);Refine H;Refine H1;
(** snd **)
Intros;Equiv Int s (V_cons P1 (V_append v1 v2)) M;
Refine snd (IH_s (V_cons P1 v1) ? ? ?);Next +1;Refine H;Refine H1;
Save t_weak_lem;

Goal {m|Nat}{t:Ty m}{v:VEC (Tm->Set) m}{M:Tm}
		(Int t v M)->
		{P:Tm->Set}Int (t_weak0 t) (V_cons P v) M;
intros;Refine fst (t_weak_lem ? ? ? (V_nil (Tm->Set)) ? ? ?);Immed;
Save t_weak_ok;

Goal {m,l:Nat}{s:Ty (succ (add l m))}{t:Ty m}
	{v1:VEC (Tm->Set) l}{v2:VEC (Tm->Set) m}{M:Tm}
	iff (Int s (V_insert v1 (Int t v2) v2) M)
	    (Int (t_subst s t) (V_append v1 v2) M);
intros m;
Refine RecTy2 m [l:Nat][s:Ty (succ (add l m))]
	{t:Ty m}{v1:VEC (Tm->Set) l}{v2:VEC (Tm->Set) m}{M:Tm}
	iff (Int s (V_insert v1 (Int t v2) v2) M) 
	    (Int (t_subst s t) (V_append v1 v2) M);
(*** t_var ***)
intros;
Refine RecVEC [l|Nat][v1:VEC (Tm->Set) l]
	{p:Fin (succ (add l m))}
	 iff (Int (t_var p) (V_insert v1 (Int t v2) v2) M) 
	     (Int (t_subst (t_var p) t) (V_append v1 v2) M);
(** v1 = V_nil **)
Refine RecFin1 [p:Fin (succ (add zero m))]
	iff (Int (t_var p) (V_cons (Int t v2) v2) M) 
	    (Int (t_subst (t_var p) t) v2 M);	
(* p =f_zero *) Refine iff_refl;
(* f_succ p *) intros; Refine iff_refl;
(** V_cons R v **)
intros R l v IH;
Refine RecFin1 [p:Fin (succ (add (succ l1) m))]
	iff (Int (t_var p) (V_insert (V_cons R v) (Int t v2) v2) M) 
	    (Int (t_subst (t_var p) t) (V_append (V_cons R v) v2) M);
(* p=f_zero *) Refine iff_refl;
(* f_succ p1 *) intros p1; 
Refine iff_trans;Next +2;Refine t_weak_lem ? ? ? (V_nil (Tm->Set)) ? ? ?;
Refine IH;
(*** arr ***)
intros l s IH_s t IH_t v1 v2 M1 P;andI;
(** fst **) 
Intros;Refine fst (IH_t ? ? ? ?);Refine H;Refine snd (IH_s ? ? ? ?);Refine H1;
(** snd **)
Intros;Refine snd (IH_t ? ? ? ?);Refine H;Refine fst (IH_s ? ? ? ?);
Refine H1;
(*** pi ***)
intros l s IH_s ____;andI;
(** fst **) 
Intros;Equiv Int (t_subst|m|(succ l) s t) (V_cons P (V_append v1 v2)) M;
Refine fst (IH_s ? (V_cons P v1) ? ?);;
Refine H;Refine H1;
(** snd **)
Intros;Refine snd (IH_s ? (V_cons P v1) ? ?);Refine H;Refine H1;
Save t_subst_lem;

Goal {m|Nat}{s:Ty (succ m)}{t:Ty m}{v:VEC (Tm->Set) m}{M:Tm}
	  (Int s (V_cons (Int t v) v) M)
	  -> (Int (t_subst0 s t) v M);
intros;Refine fst (t_subst_lem ? ? ? ? (V_nil Tm->Set) ? ?);Immed;
Save t_subst_ok;

(* 
** Interpretation of judgements
*)

(* Mod : {m,n|Nat}(Con m n)->Tm->(Ty m)->(VEC (Tm->Set) m)->Set

rec Mod m zero     empty        M T v = Int T v M
  | Mod m (succ n) (v_cons S G) M T v = 
       	{N:Tm}(Int S v N)->(Mod G (subst0 M (rep_weak0 N n)) T v)
	
*)

[Mod[m,n|Nat][G:Con m n][M:Tm][T:Ty m][v:VEC (Tm->Set) m] =
	RecVecNN 
	  ([M:Tm]Int T v M)
	  ([S:Ty m][n|Nat][G:Con m n][Mod_G:Tm->Set]
		[M:Tm]{N:Tm}(Int S v N)
			->(Mod_G (subst0 M (rep_weak0 N n))))
	  G M];

*)
(*
** Soundness
*)

Goal {m,n|Nat}{G|Con m n}{M|Tm}{T|Ty m}(Der G M T)->
	{v:VEC (Tm->Set) m}({i:Fin m}CR (V_nth i v))
	-> (Mod G M T v);
intros;
Refine RecDerN [m,n|Nat][G:Con m n][M|Tm][T|Ty m]
	{v:VEC (Tm->Set) m}({i:Fin m}CR (V_nth i v)) -> (Mod G M T v);
(*** Var ***)
intros;
Refine RecFin [n|Nat][i:Fin n]{G1:Con m1 n}
	Mod G1 (var (Fin2Nat i)) (v_nth i G1) v1;
(* var zero *)
Refine RecVecSucc [n:Nat][G1:Con m1 (succ n)]
	Mod G1 (var zero) (v_hd G1) v1;
Intros S n2 G2 N S_N;
Refine RecVec [n2|Nat][G2:Con m1 n2]Mod G2 (rep_weak0 N n2) S v1;
Refine S_N;
Intros;Refine EQ_rewrite' ? ([M:Tm]Mod l M S v1);
Next +1;Refine subst_weak_lem zero;Refine H3;
(* var (succ i) *)
intros;
Refine RecVec1 [G2 : Con m1 (succ n2)]
	Mod G2 (var (Fin2Nat (f_succ m2))) (v_nth (f_succ m2) G2) v1;
Intros;Refine H3;
(*** App ***)
intros;
Refine RecVec [n|Nat][G1:Con m1 n]
	{M1,N:Tm}(Mod G1 M1 (arr s t) v1)->(Mod G1 N s v1)
		->Mod G1 (app M1 N) t v1;
(* G = empty *)
intros;Refine H7;Refine H8;
(* G = S::G' *)
Intros;Refine H7;Refine H8;Refine H10;Refine H9;Refine H10;Refine H3;Refine H6;
Refine H5;Refine H6;
(*** Lam ***)
intros;
Refine RecVec [n1|Nat][G1:Con m1 n1]
	{M1:Tm}(Mod (v_cons s G1) M1 t v1)->(Mod G1 (lam M1) (arr s t) v1);
(* G = empty *)
intros;Refine Lam_sound;Refine CR_Int;Refine H4;Refine CR_Int;Refine H4;
Refine H5;
(* G = S::G' *)
Intros;Refine H5;Intros;Refine EQ_rewrite' ? ([M:Tm]Mod l M t v1);Next +1;
Refine subst_subst_lem zero; Refine H6; Immed;Refine H3;Refine H4;
(*** Pi_e ***)
intros;
Refine RecVec [n1|Nat][G1:Con m1 n1]
	{M1:Tm}(Mod G1 M1 (pi s) v1) -> (Mod G1 M1 (t_subst0 s t) v1);
(* G = empty *)
intros;Refine t_subst_ok;Refine H5;Refine CR_Int;Refine H4;
(* G = S::G' *)
Intros;Refine H5;Refine H6;Refine H7;
(* *) Refine H3;Refine H4;
(*** Pi_i ***)
intros;
Refine RecVec [n1|Nat][G1:Con m1 n1]
	{M1:Tm}
	({P:Tm->Set}(CR P) ->(Mod (v_map (t_weak0|m1) G1) M1 s (V_cons P v1)))
	-> (Mod G1 M1 (pi s) v1);
(* G = empty *)
intros;Refine H5;
(* G = S::G' *)
Intros;Refine H5;intros;Refine H6;Refine H8;Refine t_weak_ok;Refine H7;
(* *) intros;Refine H3;
Refine RecFin1[i:Fin (succ m1)]CR (V_nth i (V_cons P v1));
Refine H5;
Refine H4;
(*** END of CASES ***)
Immed;
Save Int_Sound;

(*
** Strong Normalisation
*)

[SN_m = RecNat ([m:Nat]VEC (Tm->Set) m)
	(V_nil (Tm->Set)) 
	([m:Nat][v:VEC (Tm->Set) m]V_cons SN v)];

Goal {m:Nat}{i:Fin m}CR (V_nth i (SN_m m));
Refine RecNat [m:Nat]{i:Fin m}CR (V_nth i (SN_m m));
Refine RecFinZero [i:Fin zero]CR (V_nth i (SN_m zero));
intros __;Refine RecFin1 [i:Fin (succ n)]CR (V_nth i (SN_m (succ n)));
Refine CR_SN;Refine H;
Save CR_SN_m;

Goal {m,n|Nat}{G|Con m n}{M|Tm}{T|Ty m}(Der G M T)->(SN M);
intros;
Claim (Mod G M T (SN_m m))->(SN M);Refine ?+1;Refine Int_Sound;
Refine H;Refine CR_SN_m;
Refine RecVec [n|Nat][G:Con m n]{M:Tm}(Mod G M T (SN_m m))->SN M;
(* G = empty *)
intros;Claim CR (Int T (SN_m m));Refine fst ?+1;Refine H1;Refine CR_Int;
Refine CR_SN_m;
(*  G = S::G' *)
intros S n1 G' ___;
Refine SNvar n1; Refine EQ_rewrite ? [X:Tm]SN (subst0 M1 X);
Next +1;Refine rep_weak0_lem;
Refine H1;Refine H2;Refine CR_nonEmpty;Refine CR_Int;Refine CR_SN_m;
Save snorm;
